#include "SDL.h"
#include "gl.h"
#include "glu.h"

#include <iostream.h>
#include <math.h>

#include <stdio.h>
#include <stdlib.h>

#include <fstream>
#include <string.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>

using namespace std;//ХЗ что это но с ним заработал строковый тип string

int i;

SDL_Surface *screen;
SDL_Surface *surface; // Gives us the information to make the texture

GLuint texture[3]; // Texture object handle



bool load(string file, GLuint &tex);

void gl2dMode (int dW,int dH);
void DrawSPR (int x,
              int y,
              int dX,
              int dY,
              int delta);






int main()
{
    //Инициализация SDL(видео) 
    if ( SDL_Init(SDL_INIT_VIDEO) != 0 ) 
     {
      printf("Unable to initialize SDL: %s\n", SDL_GetError());
      return 1;
     }


    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 ); // ХЗ

    screen = SDL_SetVideoMode( 1024, 768, 32, SDL_OPENGL/* | SDL_FULLSCREEN*/ ); // задаем экран OpenGl
    if ( !screen ) 
     {
      printf("Unable to set video mode: %s\n", SDL_GetError());
      return 1;
     }
	
    //Устанавливаем режим для OpenGL

    //Задний цвет фона зеленый (R,G,B,alpha)
    glClearColor( 0, 255, 0, 0 );
	
    glEnable( GL_TEXTURE_2D ); // надо для вывода текстуры

    gl2dMode (1024,768);

 
    //Включаем альфа канал
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);



/*
  //===Загружаем текстуры===
  char buffer[200];//для загрузки уровня
  for(i=1;i<3+1;i++)
   {
    sprintf(buffer,"image%i.bmp",i);
    if (surface = SDL_LoadBMP(buffer))  
     { 
      //Генерим GL-вскую текстуру
      glGenTextures(1, &texture[i]);
      glBindTexture( GL_TEXTURE_2D, texture[i] );
   
      //Растягиваем текстуру 

      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
      //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
      //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );

      //Текстура использует информация с поверхности SDL 
      glTexImage2D( GL_TEXTURE_2D, 0, 3, surface->w, surface->h, 0, 
                    GL_BGR, GL_UNSIGNED_BYTE, surface->pixels );
     } 
    else //иначе выходим с ошибкой 
     {
      printf("Image not load: %s\n", SDL_GetError());
      SDL_Quit();
      return 1;
     }    
    
   }//конец цикла загрузки текстур

   //Если все в норме освобождаемся от поверхности
   if ( surface ) 
    { 
     SDL_FreeSurface( surface );
    }
   //==Конец загрузки текстур==//
   
*/

    load("image2.jpg", texture[1]);
    load("test.png", texture[2]);
    load("9.tga", texture[3]);

    //Очищаем экран перед рисованием
    glClear( GL_COLOR_BUFFER_BIT );
    


    //Натягиваем текстуру и рисуем спрайт   
    glBindTexture( GL_TEXTURE_2D, texture[1] );
    DrawSPR (200,250,228,128,10);

    glBindTexture( GL_TEXTURE_2D, texture[2]);
    DrawSPR (250,280,228,128,20);

    glBindTexture( GL_TEXTURE_2D, texture[3] );
    DrawSPR (360,290,228,128,30);




    SDL_GL_SwapBuffers();
    
    // Задержка в 3 секунды
    SDL_Delay(3000);
    
    // Now we can delete the OpenGL texture and close down SDL
    glDeleteTextures( 1, &texture[1] );
    glDeleteTextures( 1, &texture[2] ); 
    glDeleteTextures( 1, &texture[3] );  
  
    SDL_Quit();
    
    return 0;
}

void gl2dMode (int dW, int dH)
 {
   // glViewport( 0, 0, dW, dH );
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    glOrtho( 0, dW, dH, 0, -1, 1 );
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
 }
    


void DrawSPR (int x,
              int y,
              int dX,
              int dY,
              int delta)
 {
    glLoadIdentity();
    glTranslatef(x,y,0);   
    glRotatef(delta,0,0,-1); 
    glTranslatef(-dX/2,-dY/2,0);

    glBegin( GL_QUADS );
        // Верхний левый угол
        glTexCoord2i(0,0);      glVertex3f( 0, 0, 0 );
        //Нижний левый угол
        glTexCoord2i( 0, 1 );   glVertex3f( 0, dY, 0 );
        //Нижний правый угол
        glTexCoord2i( 1, 1 );   glVertex3f( dX, dY, 0 );
        //Верхний правый угол
        glTexCoord2i( 1, 0 );   glVertex3f( dX, 0, 0 );
    glEnd();
 } 

bool load(string file, GLuint &tex)
 {
  SDL_Surface *temp = NULL;
  GLint maxTexSize;
  GLuint glFormat = GL_RGBA;
      
  if(file.substr(file.length()-3,3).compare("jpg") == 0)
   {
    glFormat = GL_RGB;
   }
      
  glGetIntegerv(GL_MAX_TEXTURE_SIZE, &maxTexSize); 

  temp = IMG_Load(file.data());

  if(temp == NULL)
   {
    cout << "Texture manager ERROR: " << file << " : "<< SDL_GetError() << endl;
    SDL_FreeSurface( temp );
    return 0;
   }
      
  if(temp->w > maxTexSize)
   {
    cout << "Texture manager ERROR: " << file << " texturesize too large." << endl;
   }
 
  glGenTextures(1, &tex);
  glBindTexture(GL_TEXTURE_2D, tex);

  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );

  glTexImage2D(GL_TEXTURE_2D, 0, glFormat, temp->w, temp->h, 0, glFormat, GL_UNSIGNED_BYTE, temp->pixels);
  SDL_FreeSurface( temp );

  return 1;
}
 

